routes/web.php
<?php

use App\Http\Controllers\AlumnoController;
use App\Http\Controllers\CursoController;
use App\Http\Controllers\PerteneceController;
use App\Http\Controllers\PracticaController;
use App\Http\Controllers\PresentaController;
use App\Models\Practica;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('index');
})->name('inicio');

// enrutamiento para controlador alumno
Route::resource('alumno', AlumnoController::class);

// enrutamiento para controlador curso
Route::resource('curso', CursoController::class);

// enrutamiento para todo
Route::resource('practica', PracticaController::class);
Route::resource('presenta', PresentaController::class);
Route::resource('pertenece', PerteneceController::class);

// enrutamiento adicional para practicas
Route::controller(PracticaController::class)->group(function () {
    Route::get('/practica/confirmar/{practica}', 'confirmar')->name('practica.confirmar');
});

// enrutamiento adicional para pertenece
Route::controller(PerteneceController::class)->group(function () {
    Route::get('/pertenece/confirmar/{pertenece}', 'confirmar')->name('pertenece.confirmar');
});

app/Models/Practica.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Schema;

class Practica extends Model
{
    use HasFactory;

    // nombre de la tabla
    protected $table = 'practicas';

    // campos de asignacion masiva
    protected $fillable = [
        'titulo', 'fichero', 'curso_id'
    ];



    // creamos un atributo estatico con los labels
    public static $labels = [
        'id' => 'ID',
        'titulo' => 'Título',
        'fichero' => 'Fichero de la practica',
        'curso_id' => 'Curso',
    ];

    // metodo para devolver el label de un campo
    public function getAttributeLabel($key)
    {
        return self::$labels[$key] ?? $key;
    }

    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }

    // voy a crear las relaciones
    public function presentas(): HasMany
    {
        return $this->hasMany(Presenta::class);
    }

    public function curso(): BelongsTo
    {
        return $this->belongsTo(Curso::class);
    }
}

app/Http/Controllers/PracticaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Curso;
use App\Models\Practica;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class PracticaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $practicas = Practica::all();

        return view(
            'practica.index',
            compact('practicas')
        );
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        // esto es para mostrar un dropdown en curso_id
        $cursos = Curso::all();

        return view(
            'practica.create',
            compact('cursos')
        );
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {

        // quiero crear un archivo de texto
        // y colocar hola clase
        // quiero almacenarlo en storage

        // este archivo lo crea en el disk default
        // este disco es local ==> /storage/app
        // $fichero = Storage::put('hola.txt', 'hola clase');

        // quiero un archivo que se cree en el disco public
        // el disco public ==> /storage/app/public

        // $fichero = Storage::disk('public')->put('hola.txt', 'hola clase');

        // quiero crear un archivo en el disco nuevo llamado subidas
        // este disco le he creado en el config/filesystems.php
        // subidas ==> /public/subidas
        // $fichero = Storage::disk('subidas')->put('hola.txt', 'hola clase');

        $ficheroEnviado = $request->file('fichero');
        $nombreOriginal = $ficheroEnviado->getClientOriginalName();


        // quiero almacenar en el disco public dentro de una carpeta llamadas 
        // ficheros el fichero subido


        // store(nombreCarpeta,disco) ==> lo que realiza es una copia del archivo 
        // enviado a la carpeta del disco
        // el nombre del archivo lo genera automaticamente
        $fichero = $ficheroEnviado->store('ficheros', 'public');

        // storeAs('carpeta', 'nombreOriginal', 'disco')
        // $fichero = $ficheroEnviado->storeAs('ficheros', $nombreOriginal, 'public');

        // esto lo realizaria en el disco por defecto
        // como es storage/app
        // $fichero = $ficheroEnviado->store('ficheros');


        // esto me genera el registro en la base de datos
        // automaticamente
        //$practica = Practica::create($request->all());

        // opcion 1
        // $practica = new Practica($request->all());
        // $practica->fichero = $fichero;
        // $practica->save();


        // opcion 2
        $practica = new Practica();
        $practica->fill($request->all());
        $practica->fichero = $fichero;
        $practica->save();


        return redirect()
            ->route('practica.show', $practica);
    }

    /**
     * Display the specified resource.
     */
    public function show(Practica $practica)
    {
        return view(
            'practica.show',
            compact('practica')
        );
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Practica $practica)
    {
        // esto es para mostrar un dropdown en curso_id
        $cursos = Curso::all();

        return view(
            'practica.edit',
            compact('practica', 'cursos')
        );
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Practica $practica)
    {
        // comprobar si ha subido un nuevo archivo
        if ($request->hasFile('fichero')) {

            // archivo nuevo
            // $request->file('fichero') // objeto

            // archivo antiguo
            // $practica->fichero // string 

            // recupero el archivo
            $ficheroEnviado = $request->file('fichero');

            // elimino el archivo anterior
            Storage::disk('public')->delete($practica->fichero);

            // guardo el nuevo archivo
            $fichero = $ficheroEnviado->store('ficheros', 'public');

            // actualizo el registro
            $practica->fill($request->all());

            // sustituir el nombre del archivo antiguo por el nombre
            // del archivo subido
            $practica->fichero = $fichero;
        } else {
            // si no subo un nuevo archivo
            $practica->fill($request->all());
        }

        $practica->save();

        return redirect()
            ->route('practica.show', $practica);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Practica $practica)
    {
        // elimino el archivo
        Storage::disk('public')->delete($practica->fichero);

        // elimino el registro
        $practica->delete();

        return redirect()
            ->route('practica.index');
    }

    public function confirmar(Practica $practica)
    {
        return view('practica.confirmar', compact('practica'));
    }
}

resources/views/practica/confirmar.blade.php
@extends('layouts.main')

@section('content')
    <h1>Eliminando registro</h1>
    <div>
        ¿Estas seguro de que quieres borrar el registro?
    </div>
    <div class="tarjeta">
        <ul>
            <li>id:{{ $practica->id }}</li>
            <li>Titulo:{{ $practica->titulo }}</li>
            <li>Fichero:{{ $practica->fichero }}</li>
            <li>Curso:{{ $practica->curso_id }} - {{ $practica->curso->nombre }}</li>
        </ul>
        <form action="{{ route('practica.destroy', $practica) }}" method="post" class="form-inline">
            @csrf
            @method('delete')
            <button type="submit" class="boton">Borrar</button>
        </form>
    </div>
@endsection

resources/views/practica/create.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <form action="{{ route('practica.store') }}" method="post" enctype="multipart/form-data">
            @csrf
            <div>
                <label>Titulo</label>
                <input type="text" name="titulo" required>
            </div>
            <div>
                <label>Fichero</label>
                <input type="file" name="fichero" required>
            </div>
            <div>
                <label>Curso</label>
                <select name="curso_id">
                    @foreach ($cursos as $curso)
                        <option value="{{ $curso->id }}">{{ $curso->nombre }}</option>
                    @endforeach
                </select>
            </div>
            <div>
                <button type="submit" class="boton">Enviar</button>
            </div>
        </form>
    </div>
@endSection

resources/views/practica/edit.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <form action="{{ route('practica.update', $practica) }}" method="post" enctype="multipart/form-data">
            @csrf
            @method('put')
            <div>
                <label>Titulo</label>
                <input type="text" name="titulo" required value="{{ $practica->titulo }}">
            </div>
            <div>
                <label>Fichero</label>
                <div>{{ $practica->fichero }}</div>
                <input type="file" name="fichero" value="{{ $practica->fichero }}">
            </div>
            <div>
                <label>Curso</label>
                <select name="curso_id">
                    @foreach ($cursos as $curso)
                        <option value="{{ $curso->id }}" {{ $practica->curso_id == $curso->id ? 'selected' : '' }}>
                            {{ $curso->nombre }}</option>
                    @endforeach
                </select>
            </div>
            <div>
                <button type="submit" class="boton">Enviar</button>
            </div>
        </form>
    </div>
@endSection

resources/views/practica/index.blade.php
@extends('layouts.main')

@section('content')
    {{-- muestro todas las practicas que me manda el controlador --}}
    <div class="listado">
        @foreach ($practicas as $practica)
            <div class="tarjeta">
                <ul>
                    <li>id:{{ $practica->id }}</li>
                    <li>Titulo:{{ $practica->titulo }}</li>
                    <li>Fichero:{{ $practica->fichero }}</li>
                    <li>Curso:{{ $practica->curso_id }} - {{ $practica->curso->nombre }}</li>
                </ul>
                <div class="botones">
                    <a href="{{ route('practica.show', $practica) }}" class="boton">Ver</a>
                    <a href="{{ route('practica.edit', $practica) }}" class="boton">Actualizar</a>
                    <form action="{{ route('practica.destroy', $practica) }}" method="post" id="eliminar"
                        class="form-inline">
                        @csrf
                        @method('delete')
                        <button type="submit" class="boton">Borrar</button>
                    </form>
                    <a href="{{ route('practica.confirmar', $practica) }}" class="boton">Eliminar de otra forma</a>
                </div>
            </div>
        @endforeach
    </div>
@endsection

resources/views/practica/show.blade.php
@extends('layouts.main')

@section('content')
    <div class="tarjeta">
        <ul>
            <li>id:{{ $practica->id }}</li>
            <li>Titulo:{{ $practica->titulo }}</li>

            <li>Fichero: <a href="{{ asset('storage/' . $practica->fichero) }}"> {{ $practica->fichero }}</a></li>

            <li>Curso:{{ $practica->curso_id }} - {{ $practica->curso->nombre }}</li>
        </ul>
        <div class="botones">
            <a href="{{ route('practica.edit', $practica) }}" class="boton">Actualizar</a>
            <form action="{{ route('practica.destroy', $practica) }}" method="post" id="eliminar" class="form-inline">
                @csrf
                @method('delete')
                <button type="submit" class="boton">Borrar</button>
            </form>
            <a href="{{ route('practica.confirmar', $practica) }}" class="boton">Eliminar otra forma</a>
        </div>
    </div>
@endsection